module Code where {

import Language.Haskell.TH;
import Control.Monad.ST;
import Data.List;
import MyRewrites;

code1 :: Q [Dec];
code1 = [d| 
{-
ww_sort_1 body = wrapper (worker body)
 where
   wrapper :: (forall s . [Int] -> ST s [Int]) -> [Int] -> [Int]
   wrapper work xs = runST (work xs)

   worker :: ([Int] -> [Int]) -> [Int] -> ST s [Int]
   worker code xs = return (code xs)
-}
{-
sort []     = []
sort (x:xs) = Code.sort (filter (< x) xs) ++ [x] ++ Code.sort (filter (>= x) xs)
{-
sort = let fn_112 = \ x1_109 ->
                    return
                      (case x1_109 of
                         [] -> []
                         (x_97 : xs_98)
                           -> sort (filter ( < x_97) xs_98) ++
                              ([x_97] ++ sort (filter ( >= x_97) xs_98))
                      )
           fn_112 :: forall s . [Int] -> ST s [Int]
        in \ x1_109 -> runST (fn_112 x1_109)
-}
-}
{-
filter = \ x0 x1 ->
         case x1 of
           (a : as)
             -> if x0 a
                 then MyRewrites.fListToList
                        (MyRewrites.fcons
                           a
                           (MyRewrites.listToFList (filter x0 as))
                        )
                 else MyRewrites.fListToList (MyRewrites.listToFList (filter x0 as))
           [] -> MyRewrites.fListToList MyRewrites.fnil

-}
{-
filter = \ x0_75 x1_76 ->
         MyRewrites.fListToList
           (case x1_76 of
              (a_77 : as_78)
                -> case x0_75 a_77 of
                     True
                       -> MyRewrites.fcons
                            a_77 (MyRewrites.listToFList (filter x0_75 as_78))
                     False -> MyRewrites.listToFList (filter x0_75 as_78)
              [] -> MyRewrites.fnil
           )
-}

filter = \ x0_75 x1_76 ->
         MyRewrites.fListToList (fn_79 x0_75 x1_76)
fn_79 = \ x0_75 x1_76 ->
        case x1_76 of
          (a_77 : as_78)
            -> case x0_75 a_77 of
                 True
                   -> MyRewrites.fcons
                        a_77 (MyRewrites.listToFList (filter x0_75 as_78))
                 False -> MyRewrites.listToFList (filter x0_75 as_78)
          [] -> MyRewrites.fnil

|];


}	
